#include <setjmp.h>
#include <stdio.h>
#include <signal.h>

#include "helper.c"

static jmp_buf env_alrm;

static void
sig_alrm (int signo)
{
  printf ("Caught alrm\n");
  longjmp (env_alrm, 1);
}

int
main (int argc, char *argv[])
{
  int jumped = 0;

  if (signal (SIGALRM, sig_alrm) == SIG_ERR)
  {
    fprintf (stderr, "Could not set up SIGALRM handler\n");
    return -1;
  }

  /* set up jmp buffer */
  if (setjmp (env_alrm) != 0)
  {
    fprintf (stderr, "jumped here from alrm handler\n");
    jumped = 1;
  }

  if (!jumped)
  {
    /* we didn't jump here, so we arrived here naturally */

    /* set us up the bomb */
    alarm (1);
    printf ("Going endless\n");
    endless ();
  }

  printf ("Done going endless\n");

  return 0;
}
